<?php
// $Id: xoopsMatter.php,v 1.10 2003/04/01 22:51:21 mvandam Exp $
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
// Author: Kazumi Ono (AKA onokazu)                                          //
// URL: http://www.myweb.ne.jp/, http://www.xoops.org/, http://jp.xoops.org/ //
// Project: The XOOPS Project                                                //
// ------------------------------------------------------------------------- //
include_once XOOPS_ROOT_PATH."/mainfile.php";
include_once XOOPS_ROOT_PATH."/class/database/database.php";
include_once XOOPS_ROOT_PATH . '/modules/shoppingcart/language/' . $xoopsConfig['language'] . '/currency.php';

class ShoppingCart
{
	var $db;
	var $cartid;
	var $matterid;
	var $uid;
	var $units;
	var $cdate;
	var $udate;
	
	function ShoppingCart(){
		$this->db =& Database::getInstance();
		$this->cartid = -1;
	}
	function getCart($uid,$mid ){
		$sql = sprintf("SELECT * FROM " .	$this->db->prefix('shoppingcart_cart')  . ' WHERE uid=%u AND matterid=%u' ,$uid,$mid );
		$rs = $this->db->query($sql);
		$this->cartid = -1;
		$this->units = 0;
		if(!$rs){
			return(FALSE);
		}
		$rr = $this->db->fetchArray($rs);
		foreach($rr as $k => $v){
			$this->$k = $v;
		}

	}
	
	function setUnits($cartid,$units){
		if($units > 0){
			$sql = sprintf("UPDATE  ".$this->db->prefix('shoppingcart_cart')." SET units = %u WHERE cartid = %u",$units,$cartid);
		}
		else{		
			$sql = sprintf("DELETE  FROM ".$this->db->prefix('shoppingcart_cart')." WHERE cartid = %d ",$cartid);
		}
		return($this->db->queryF($sql));
	}
	
	function getCartFromID($cartid ){
		$sql = sprintf("SELECT * FROM " .	$this->db->prefix('shoppingcart_cart')  . ' WHERE cartid=%u' ,$cartid );
		$rs = $this->db->query($sql);
		$this->cartid = -1;
		$this->units = 0;
		if(!$rs){
			return(FALSE);
		}
		$rr = $this->db->fetchArray($rs);
		foreach($rr as $k => $v){
			$this->$k = $v;
		}

	}
	
	function store(){
		if($this->units > 0){
			if($this->cartid < 0){
				$sql = sprintf("INSERT INTO ".$this->db->prefix('shoppingcart_cart')." (matterid,cdate,units,uid) VALUES ('%s',NOW(),%u,%u)", $this->matterid,$this->units,$this->uid);
			} 
			else
			{
				$sql = sprintf("UPDATE  ".$this->db->prefix('shoppingcart_cart')." SET units = %u WHERE cartid = %d ",$this->units,$this->cartid);
			}
		}
		else{
			$sql  = sprintf("DELETE FROM ".$this->db->prefix('shoppingcart_cart')." WHERE cartid = %d ",$this->cartid);
		}
		
		if (!$result = $this->db->queryF($sql)) {
			return false;
		}
		if($this->cartid < 0){
			$this->cartid = $this->db->getInsertId();
		}
		return(true);
	}

	function delete(){
		$sql = "DELETE FROM  ". $this->db->prefix('shoppingcart_cart') ." WHERE cartid=" . $this->cartid;
		$this->cartid = -1;
		if (!$result = $this->db->queryF($sql)) {
			return false;
		}
		return(true);
	}
	
	function countAll($uid){
		$cart = $this->db->prefix('shoppingcart_cart');
		$matter = $this->db->prefix('shoppingcart_matter');
		$sql = 'SELECT ' . $matter . ".title," . $matter . ".price," . $cart . ".units," . $matter .".matterid," . $cart  . ".cartid,"  . $matter .".max ";
		$sql .= (" FROM " . $cart . "," . $matter . " WHERE ");
		$sql .= ($cart . '.matterid = ' . $matter . ".matterid " . " AND uid=" . $uid );
		$rr = array();
		$res = $this->db->query($sql);
		if(!$res){
			return($rr);
		}
		while($src = $this->db->fetchRow($res)){
			$dst = array();
			$dst['title'] = $src[0];
			$dst['price'] = $src[1];
			$units = intval($src[2]);
			$dst['units'] = $units;
			$dst['matterid'] = intval($src[3]);
			$dst['cartid'] = intval($src[4]);
			$max= intval($src[5]);
			$dst['sellist'] = '';
			for($i = 0 ; $i <=$max;$i++){
				$dst['sellist'] .= sprintf("<option value='%u' %s>",$i,($i == $units) ? 'selected' : '');
				$dst['sellist'] .= ($i == 0) ? _NW_NOTSEL : $i;
				$dst['sellist'] .= '</option>';
			}
			$rr[] = $dst;
			unset($dst);
		}
		return($rr);
	}

	function clearCart($uid){
		$sql = "DELETE FROM  ". $this->db->prefix('shoppingcart_cart') ." WHERE uid=" . $uid;
		if (!$result = $this->db->queryF($sql)) {
			return false;
		}
		return(true);
	}

}

class ShoppingMatter
{
	var $db;
	var $title;
	var $matterid;
	var $image;
	var $title;
	var $bodytext;
	var $disporder;
	var $nosmily;
	var $nohtml;
	var $cdate;
 	var $max;
	var $price;

	function ShoppingMatter($sid = -1)
	{
		$this->db =& Database::getInstance();
		$this->matterid = $sid;
		if($sid  >= 0){
			$sql = sprintf("SELECT * FROM "  . $this->db->prefix('shoppingcart_matter') ." WHERE matterid=%u" , $this->matterid);
			$arr= $this->db->fetchArray($this->db->query($sql));
			foreach($arr as $k => $v){
				$this->$k = $v ;
			}
		}
	}

	function sanitizeMatter($src){
		$myts =& MyTextSanitizer::getInstance();
		$dst = array();
		$smily = 1;
		$html = 1;
		if(intval($src['nosmily']) == 1){
			$smily = 0;
		}
		if(intval($src['nohtml']) == 1){
			$html = 0;
		}
		foreach(array_keys($src) as $key){
			switch($key){
				case 'nosmily' :
				case 'nohtml' :
					break;
				case 'bodytext' :
				case 'title' :
					
					$dst[$key] = $myts->makeTareaData4Show($src[$key],$html, $smily, 1);
					break;
				default:
					$dst[$key] = $src[$key];
			}
		}
		return($dst);
	}

	function imageSet($fn)
	{
		$fp = fopen($fn ,"rb");
		if(feof($fp)){
			return(FALSE);
		}
		
		$imgstr = fread($fp,filesize($fn));
		fclose($fp);
		$img = imagecreatefromstring($imgstr);
		$tmpfn = tempnam(XOOPS_ROOT_PATH.'/modules/shoppingcart/images/','jpeg_') ;
		if(!imagejpeg($img,$tmpfn)){
			return(FALSE);
		}
		imagedestroy($img);
		$fp = fopen($tmpfn ,"rb");
		if(feof($fp)){
			return(FALSE);
		}
		
		$imgstr = fread($fp,filesize($tmpfn));
		fclose($fp);
		unlink($tmpfn);
		$this->image = $imgstr;
		return(TRUE);

	}

	function store()
	{
		$myts =& MyTextSanitizer::getInstance();
		$ttl =$myts->censorString($this->title);
		$ttl = $myts->makeTboxData4Save($ttl);
		$btext =$myts->censorString($this->bodytext);
		$btext = $myts->makeTareaData4Save($btext);
		$img = mysql_escape_string ($this->image);
		if ( !isset($this->nosmily) || $this->nosmily != 1 ) {
			$this->nosmily = 0;
		}

		if ( !isset($this->nohtml) || $this->nohtml != 1 ) {
			$this->nohtml = 0;
		}
		if ( $this->matterid < 0 ){
			$sql = sprintf("INSERT INTO  ".$this->db->prefix('shoppingcart_matter')." (disporder,title,cdate,price,max,nohtml,nosmily,bodytext,image) VALUES ('%d','%s',NOW(),%u,%u,%u,%u,'%s','%s')", $this->disporder,$ttl,$this->price,$this->max,$this->nohtml, $this->nosmily,$this->bodytext,$img);
		} 
		else
		{
			$sql = sprintf("UPDATE  ".$this->db->prefix('shoppingcart_matter')." SET disporder=%d,title ='%s',price=%u,max=%u,bodytext = '%s',nohtml = %u,nosmily = %u ,image='%s' WHERE matterid = %u ",$this->disporder,$ttl, $this->price,$this->max,$btext,$this->nohtml,$this->nosmily,$img,$this->matterid);
			$newmatterid = $this->matterid;
		}
		if (!($result = $this->db->queryF($sql))) {
			return false;
		}
		if ( empty($newmatterid) ) {
			$newmatterid = $this->db->getInsertId();
			$this->matterid = $newmatterid;
		}

		return $newmatterid;
	}

	function getMatterList($adminflg,$maxcnt = -1,$start = -1)
	{			
		if($sid < 0){
			$sid = $this->matterid;
		}
		$sql = "SELECT matterid FROM  ".$this->db->prefix('shoppingcart_matter');
		if(!$adminflg){
			$sql .= ' WHERE  disporder > 0 ';
		}
		$sql .= ' ORDER BY disporder ASC,matterid DESC  ';
		if($maxcnt > 0){
			$sql  =  sprintf('%s LIMIT %u',$sql,$maxcnt);
			if($start > 0){
				$sql = sprintf('%s,%u',$sql,$start);
			}
		}
		$dst = array();
		$res = $this->db->query($sql);
		if(!$res){
			return($rr);
		}
		while($src = $this->db->fetchRow($res)){
			$dst[] = $src[0];
			
		}
		return($dst);
	}


	function delete()
	{
		$sql = sprintf("DELETE FROM ".$this->db->prefix('shoppingcart_matter')." WHERE matterid = %u", $this->matterid);
		if( !$result = $this->db->query($sql) ) {
			return false;
		}
		return true;
	}

	function outTitle($format="Show")
	{
		$myts =& MyTextSanitizer::getInstance();
		$smily = 1;
		if ( $this->nosmily ) {
			$smily = 0;
		}
		$html = 1;
		if ( $this->nohtml ) {
			$html = 0;
		}
		switch ( $format ) {
		case "Show":
			$title = $myts->makeTboxData4Show($this->title,$html,$smily);
			break;
		case "Edit":
			$title = $myts->makeTboxData4Edit($this->title);
			break;
		case "Preview":
			$title = $myts->makeTboxData4Preview($this->title,$html,$smily);
			break;
		case "InForm":
			$title = $myts->makeTboxData4PreviewInForm($this->title);
			break;
		}
		return $title;
	}

	function outBodytext($format="Show")
	{
		$myts =& MyTextSanitizer::getInstance();
		$smily = 1;
		$xcodes = 1;

		if ( $this->nosmily) {
			$smily = 0;
		}
		$html = 1;
		if ( $this->nohtml ) {
			$html = 0;
		}
		switch ( $format ) {
		case "Show":
			$bodytext = $myts->makeTareaData4Show($this->bodytext,$html,$smily,$xcodes);
			break;
		case "Edit":
			$bodytext = $myts->makeTareaData4Edit($this->bodytext);
			break;
		case "Preview":
			$bodytext = $myts->makeTareaData4Preview($this->bodytext,$html,$smily, $xcodes);
			break;
		case "InForm":
			$bodytext = $myts->makeTareaData4PreviewInForm($this->bodytext);
			break;
		}
		return $bodytext;
	}

}
?>
